#define _JPI_WIN_
#include <stdlib.h>
#include <conio.h>

void bezier_demo(void);
void bounce_demo(void);
void contour_demo(void);
void curve_demo(void);
void logo_demo(void);
void maze_demo(void);
void point_demo(void);

int menu(void) {

  clrscr();
  cputs("    =========== JPI Graphics Demo Routines ===============\n\n");
  cputs("            Press Number Key To Select Routine\n\n");
  cputs("        Bezier Curves                                  0\n");
  cputs("        Bouncing figures                               1\n");
  cputs("        Trigonometric Contour Curves                   2\n");
  cputs("        Space Filling Curves                           3\n");
  cputs("        Tumbling JPI Logo                              4\n");
  cputs("        Drunk In A Maze                                5\n");
  cputs("        Fatal Attraction                               6\n");
  cputs("        Back To Reality                                7\n");
  return getch()-'0';
}

main() {

  while(1) {
    switch(menu()) {
      case 0:
        bezier_demo();
        break;
      case 1:
        bounce_demo();
        break;
      case 2:
        contour_demo();
        break;
      case 3:
        curve_demo();
        break;
      case 4:
        logo_demo();
        break;
      case 5:
        maze_demo();
        break;
      case 6:
        point_demo();
        break;
      case 7:
        clrscr();
        exit(0);
    }
  }
  return 0;
}