IMPLEMENTATION UNIT MenuP;

IMPORT PASWIN,PASDOS;

CONST
  UpArrow=04800h;
  DownArrow=05000h;
  Enter=0Dh;
  Escape=01Bh;

  IMPLEMENTATION OF MenuItem;

    PROCEDURE SetUp;
      BEGIN
        Next:=NIL;
        Quick:=q;
        Heading:=name;
        Datum:=retval;
        ChildResponse:=-1;
        Child:=ch
      END;

    PROCEDURE Kill;
      BEGIN
        IF (Next<>NIL) THEN BEGIN
          Next^.Kill;
          Dispose(Next)
        END;
      END;

    PROCEDURE PLEQ;
      BEGIN
        IF Next<>NIL THEN
          Next^.PLEQ(Me)
        ELSE
          Next:=Me
      END;

    FUNCTION Item;
      BEGIN
        IF n=0 THEN
          Item:=ADR(Self)
        ELSE
          IF Next<>NIL THEN
            Item:=Next^.Item(n-1)
          ELSE
            Item:=NIL
      END;

    FUNCTION FindSelChar;
      BEGIN
        IF c=Quick THEN
          FindSelChar:=0
        ELSE
          IF Next<>NIL THEN
            FindSelChar:=Next^.FindSelChar(c)+1
          ELSE
            FindSelChar:=-128
      END;

    FUNCTION FindResult;
      BEGIN
        IF l=Datum THEN
          FindResult:=0
        ELSE
          IF Next<>NIL THEN
            FindResult:=Next^.FindResult(l)+1
          ELSE
            FindResult:=-128
      END;
  BEGIN
  END;

  IMPLEMENTATION OF MenuBlock;

    PROCEDURE Blank;
      BEGIN
        head:=NIL;
        nitems:=0;
        maxlen:=0;
        x1:=-1;
        y1:=-1;
        backg:=PasWin.LightGray;
        foreg:=PasWin.Blue;
        selback:=PasWin.Cyan;
        selfore:=PasWin.Blue;
        highback:=PasWin.LightGray;
        highfore:=PasWin.Red;
        highselback:=PasWin.Cyan;
        highselfore:=PasWin.Red;
      END;

    PROCEDURE SetUp;
      BEGIN
        Blank;
        x1:=x;
        y1:=y
      END;

    PROCEDURE Kill;
      BEGIN
        IF Head<>NIL THEN BEGIN
          Head^.Kill;
          Dispose(Head)
        END
      END;

    PROCEDURE AddItem;
      VAR
        Temp:MenuItemP;
        t:BYTE;
      BEGIN
        New(Temp);
        Temp^.SetUp(chr(ORD(selch) AND 05FH),title,nitems,kid);
        nitems:=nitems+1;
        IF Head=NIL THEN
          Head:=Temp
        ELSE
          Head^.PLEQ(Temp);
        t:=Length(title);
        IF kid<>NIL THEN
          t:=t+1;
        IF t>maxlen THEN
          maxlen:=t
      END;

    PROCEDURE OutLine;
      VAR
        NormFore,NormBack,HFore,HBack:PasWin.Color;
        I,Textlen:BYTE;
        H:CHAR;
      BEGIN
        IF NOT Current THEN BEGIN
          NormBack:=backg;
          NormFore:=foreg;
          HFore:=highfore;
          HBack:=highback
        END
        ELSE BEGIN
          NormBack:=selback;
          NormFore:=selfore;
          HFore:=highselfore;
          HBack:=highselback;
        END;
        Textlen:=Length(x^.Heading);
        H:=x^.Quick;
        PasWin.Foreground(NormFore);
        PasWin.Background(NormBack);
        FOR I:=1 TO Textlen DO
          IF CHR(ORD(x^.Heading[i]) AND 05FH)=H THEN BEGIN
            PasWin.Foreground(HFore);
            PasWin.Background(HBack);
            WRITE(x^.Heading[i]);
            H:=0C;
            PasWin.Foreground(NormFore);
            PasWin.Background(NormBack)
          END
          ELSE
            WRITE(x^.Heading[i]);
        FOR I:=Textlen TO maxlen-2 DO
          WRITE(' ');
        IF Textlen<maxlen THEN
          IF x^.Child=NIL THEN
            WRITE(' ')
          ELSE
            WRITE(CHR(16))
      END;

    PROCEDURE Draw;
      VAR
        I:BYTE;
      BEGIN
        PasWin.Clear(PasWin.Clear_Screen);
        FOR I:=0 TO nitems-1 DO BEGIN
          Outline(head^.Item(I),I=cpos);
          IF i<nitems-1 THEN
            WRITELN
        END
      END;

    FUNCTION Execute;
      VAR
        Top,Left:BYTE;
        OCpos,Cpos,t:INT8;
        W:PasWin.PopUpWin;
        hit:MenuItemP;
        Exit:BOOLEAN;
        Key:INT16;

      PROCEDURE FireCpos;
        BEGIN
          hit:=Head^.Item(cpos);
          IF hit^.Child<>NIL THEN
            WITH hit^ DO BEGIN
              draw(cpos);
              ChildResponse:=Child^.Execute(ChildResponse);
              IF ChildResponse<>-1 THEN BEGIN
                Execute:=ChildResponse+100*(Cpos::INTEGER);
                Exit:=TRUE
              END
            END
          ELSE BEGIN
            Execute:=hit^.Datum;
            Exit:=TRUE
          END
        END;

      BEGIN
        IF Head=NIL THEN
          Execute:=-1
        ELSE BEGIN
          IF x1<0 THEN
            Left:=(ScreenWidth-maxlen-1) DIV 2
          ELSE
            Left:=x1;
          IF y1<0 THEN
            Top:=(ScreenDepth-nitems-1) DIV 2
          ELSE
            Top:=y1;
          W.Open(Left,Top,maxlen,nitems,foreg,backg);
          W.FrameDraw(PasWin.SingleFrame,foreg,backg,false);
          W.WrapOn:=FALSE;
          PasWin.CursorOff;
          Cpos:=Head^.FindResult(Starting);
          IF Cpos<0 THEN
            Cpos:=0;
          Execute:=-1;
          Draw(Cpos);
          REPEAT
            Exit:=FALSE;
            OCpos:=Cpos;
            Key:=ORD(PasDos.RdKey);
            IF Key=0C THEN
              Key:=ORD(PasDos.RdKey)*256;
            CASE Key OF
              Escape:Exit:=TRUE;
              DownArrow: BEGIN
                  Cpos:=Cpos+1;
                  IF Cpos>=nitems THEN
                    Cpos:=0
                END;
              UpArrow: BEGIN
                  Cpos:=Cpos-1;
                  IF Cpos<0 THEN
                    Cpos:=nitems-1
                END;
              Enter: FireCpos;
              ELSE BEGIN
                t:=head^.FindSelChar(CHR(ORD(CHR(Key)) AND 05FH));
                IF t>=0 THEN BEGIN
                  Cpos:=t;
                  FireCpos;
                END
              END
            END;
            IF OCpos<>Cpos THEN BEGIN
              PasWin.GoToXY(1,Cpos+1);
              Outline(head^.Item(cpos),TRUE);
              PasWin.GotoXY(1,OCpos+1);
              Outline(head^.Item(OCpos),FALSE)
            END
          UNTIL Exit
        END;
        W.Close;
      END;
    BEGIN
    END;

  BEGIN
  END.