/* JPI TopSpeed C demo: Bouncing Points.          HUR 27/10/89 */
/*                                                             */
/* COPYRIGHT (C) 1989 Jensen and Partners. All Rights Reserved */

#define _JPI_WIN_
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <choose.h>

#define MAX  5

extern struct videoconfig cv;

void point_demo()
{
  unsigned int x, y, N, L, M, P, X[MAX], Y[MAX];
  char C;

  clrscr();
  cputs ( "    A point is randomly bounced towards a number\n" );
  cputs ( "    of attractor points determining its color.\n\n" );
  cputs ( "    Use <SPACE> to stop at each pattern.\n" );
  cputs ( "    Use any other key to resume free run.\n\n" );
  cputs ( "    Press a key to start...<ESC> to stop\n" );
  C = getch();

  Choose ();

  randomize ();
  N = 3;
  X[0] = 0;               Y[0] = cv.numypixels-1;
  X[1] = cv.numxpixels-1; Y[1] = cv.numypixels-1;
  X[2] = cv.numxpixels/2; Y[2] = 0;
  M = 10000;
  do
  {
    x = random ( cv.numxpixels );
    y = random ( cv.numypixels );
    _clearscreen ( _GCLEARSCREEN );
    for (L = 0; L < M && !kbhit(); ++L)
    {
      P = random ( N );
      x = (x + X[P]) / 2;
      y = (y + Y[P]) / 2;
      if (L > 10)
      {
        _setcolor ( 1 + P % (cv.numcolors-1) );
        _setpixel ( x, y );
      }
    }
    if (kbhit() || C == ' ') C = getch ();
    N = 3 + random ( MAX-2 );
    for (P = 0; P < N; ++P)
    {
      X[P] = random ( cv.numxpixels );
      Y[P] = random ( cv.numypixels );
    }
    M = 3 * cv.numxpixels * N;
  }
  while (C != 27);
  _setvideomode( _DEFAULTMODE );
}
