(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)
IMPLEMENTATION unit PWMain;

IMPORT Windows;

CONST
(* String table constants *)
  IDSNAME  =   100;
  IDSABOUT =   200;
  IDSTITLE =   300;

(* About Dialog box resource id *)
  ABOUTBOX =     1;

VAR
  szAppName: ARRAY [0..9] OF CHAR;
  szAbout: ARRAY [0..9] OF CHAR;
  szMessage: ARRAY [0..25] OF CHAR;
  MessageLength: word;

  hInst: Windows.HANDLE;
  lpprocAbout: Windows.FARPROC;

PROCEDURE MessagePaint(hdc: Windows.HDC);

BEGIN
  Windows.TextOut(hdc, 10, 10, szMessage, MessageLength );
END ;


(* Procedures which make up the window class. *)
FUNCTION WndProc{hWnd: Windows.HWND; message: word; wParam: word; lParam: integer ): integer};
label 999;
VAR
    ps: Windows.PAINTSTRUCT;
BEGIN
    CASE message OF
        Windows.WM_SYSCOMMAND:
            CASE wParam OF
                IDSABOUT:
                    Windows.DialogBox( hInst, ((ABOUTBOX:>integer):>FarADDRESS)^, hWnd, lpprocAbout );
                ELSE
                    WndProc :=Windows.DefWindowProc( hWnd, message, wParam, lParam);
                    GOTO 999;
            END;
         Windows.WM_DESTROY:
            Windows.PostQuitMessage(0);
         Windows.WM_PAINT:
            BEGIN
               Windows.BeginPaint(hWnd, ps);
               MessagePaint(ps.hdcM);
               Windows.EndPaint(hWnd, ps);
            END;
        ELSE
            WndProc := Windows.DefWindowProc( hWnd, message, wParam, lParam);
            goto 999;
    END;
    WndProc := 0;
    999:
END ;

FUNCTION About { hDlg    : Windows.HWND;
                 message : word;
                 wParam  : WORD;
                 lParam  : integer ) : Windows.BOOL };

BEGIN
  CASE message OF
    Windows.WM_COMMAND:
      BEGIN
        Windows.EndDialog( hDlg, (TRUE::word) );
        About := (TRUE::int16);
      END;
    Windows.WM_INITDIALOG :
       About := (TRUE::int16);
    ELSE
      About := (FALSE::int16);
    END;
END ;


(* This procedure called when the program is loaded for the first time *)

FUNCTION DemoInit(hInstance: Windows.HANDLE): BOOLEAN;

VAR
  DemoClass: Windows.WNDCLASS;
  IconName : ARRAY[1..10] OF CHAR;
BEGIN
(* Load strings from resource *)
  Windows.LoadString(hInstance, IDSNAME, szAppName, 10);
  Windows.LoadString(hInstance, IDSABOUT, szAbout, 10);
  MessageLength:=Windows.LoadString(hInstance, IDSTITLE, szMessage, 25);

  DemoClass.hCursorM := Windows.LoadCursor((0:>Windows.HANDLE), (Windows.IDC_ARROW:>FarADDRESS)^);
  StrToZ('wdemo',IconName);
  DemoClass.hIconM := Windows.LoadIcon(hInstance,IconName);
  DemoClass.lpszMenuName := FarNIL;
  DemoClass.lpszClassName := (FarADR(szAppName):>Windows.LPSTR);
  DemoClass.hbrBackground := (Windows.GetStockObject(Windows.WHITE_BRUSH):>Windows.HBRUSH);
  DemoClass.hInstance:=hInstance;
  DemoClass.style := Windows.CS_HREDRAW + Windows.CS_VREDRAW;
  DemoClass.lpfnWndProc := FarADR(WndProc);
  DemoClass.cbClsExtra := 0;
  DemoClass.cbWndExtra := 0;

  IF Windows.RegisterClass(DemoClass) = 0 THEN
    DemoInit := FALSE (* Initialization failed. *)
  ELSE
    DemoInit :=TRUE;  (* Success *)

END ;


FUNCTION WinMain{hInstance: Windows.HANDLE; hPrevInstance: Windows.HANDLE; lpszCmdLine: Windows.LPSTR; cmdShow: int16): Windows.BOOL};
label 999;
VAR
    msg: Windows.MSG;
    hWnd: Windows.HWND;
    hMenu: Windows.HMENU;
BEGIN
    IF hPrevInstance = (0:>Windows.HANDLE) THEN
    BEGIN
        (* Call initialization procedure if this is the first instance *)
        IF NOT DemoInit(hInstance) THEN
        begin
          WinMain := (FALSE::int16);
          goto 999;
        end;
    END
    ELSE BEGIN
        (* Copy data from previous instance *)
        Windows.GetInstanceData(hPrevInstance, NearADR(szAppName), 10);
        Windows.GetInstanceData(hPrevInstance, NearADR(szAbout), 10);
        Windows.GetInstanceData(hPrevInstance, NearADR(szMessage), 25);
        Windows.GetInstanceData(hPrevInstance, NearADR(MessageLength), SIZE(int16));
    END;

    hWnd := Windows.CreateWindow(FarADR(szAppName)^,
                        szMessage,
                        Windows.WS_TILEDWINDOW ,
                        Windows.CW_USEDEFAULT,
                        Windows.CW_USEDEFAULT,
                        Windows.CW_USEDEFAULT,
                        Windows.CW_USEDEFAULT,
                        (0:>Windows.HWND),        (* no parent *)
                        (0:>Windows.HMENU),        (* use class menu *)
                        hInstance,     (* handle to window instance *)
                        FarNIL^         (* no params to pass on *)
                        );

    (* Save instance handle for DialogBox *)
    hInst := hInstance;
    lpprocAbout := Windows.MakeProcInstance( (FarADR(About):>Windows.FARPROC), hInstance );

    (* Insert About *)
    hMenu:= Windows.GetSystemMenu(hWnd, Windows.WFalse);
    Windows.ChangeMenu(hMenu, 0, FarNIL^, 999, Windows.MF_APPEND + Windows.MF_SEPARATOR);
    Windows.ChangeMenu(hMenu, 0, FarADR(szAbout)^, IDSABOUT, Windows.MF_APPEND + Windows.MF_STRING);

    (* Make window visible according to the way the app is activated *)
    Windows.ShowWindow(hWnd, cmdShow);
    Windows.UpdateWindow(hWnd);

    (* Polling messages from event queue *)
    WHILE (Windows.GetMessage(msg, (0:>Windows.HWND), 0, 0)) <> 0 DO
    BEGIN
        Windows.TranslateMessage(msg);
        Windows.DispatchMessage(msg);
    END;
    WinMain :=  msg.wParam;
    999:
END ;

END .
