/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  biosio.h -  header file for Modula-2 file Bios IO procedures            *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved       *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2BIOSIO_INC
#define _M2BIOSIO_INC

#pragma save
#pragma name(prefix=>"")

#ifdef __cplusplus
extern "Modula2" {
#endif

int BiosIO$KeyPressed(void);
/* Check if key pressed */

int BiosIO$RdKey(void);
/* Return keys without echo */

int BiosIO$RdChar(void);
/* Return keys with echo */

#define BiosIO$RShift 1
#define BiosIO$LShift 2
#define BiosIO$Ctrl   4
#define BiosIO$Alt    8
#define BiosIO$Scroll 16
#define BiosIO$Num    32
#define BiosIO$Cap    64
#define BiosIO$Ins    128

unsigned int KBFlags(void);
/* Returns current 'shift' keys depressed */
#ifdef __cplusplus
}
#endif

#pragma restore
#endif
