/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  mathlib.h -  header file for Modula-2 file math procedures              *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2MATHLIB_INC
#define _M2MATHLIB_INC

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)


/* 8087 instructions */


typedef struct {
    unsigned char PackedBcd[10];
} PackedBcd;


typedef struct _FPEnvironment {
     unsigned ControlWord, StatusWord, TagWord;
     unsigned IP, Opcode;
     unsigned DataPointer, R80287;
} FPEnvironment;

#ifdef __cplusplus
extern "C" {
#endif
PackedBcd     Mathlib$LongToBcd(double x);
double        Mathlib$BcdToLong(PackedBcd A);

void          Mathlib$LoadControlWord(unsigned C);
unsigned      Mathlib$StoreControlWord(void);
void          Mathlib$ClearExceptions(void);
FPEnvironment Mathlib$StoreEnvironment(void);
#ifdef __cplusplus
}
#endif


#pragma restore
#endif
