/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  pasproc.h -  header file for PasProc                                    *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _PASPROC_INC
#define _PASPROC_INC

#pragma project("#set tspas='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)
#pragma name(upper_case=>on)

#define  MaxProcess  32

#include <process.h>

#ifdef __cplusplus
extern "C" {
#endif
void   PASPROC$StartProcess(void (far *_P)(void), unsigned _N, unsigned _Pr);
#pragma save
#pragma call(reg_saved=>(ds,di,si,st1,st2))
void   PASPROC$StartScheduler(void);
void   PASPROC$StopScheduler(void);
void   PASPROC$StopProcess(void);
void   PASPROC$SEND(SIGNAL _s);
void   PASPROC$WAIT(SIGNAL _s);
void   PASPROC$Notify(SIGNAL _s);
int    PASPROC$Awaited(SIGNAL _s);
void   PASPROC$Init(SIGNAL *_s);
void   PASPROC$ProcessDelay(unsigned _T);
#pragma restore

#pragma save
#pragma call(c_conv=>off, near_call=>off, reg_saved => (ax,bx,cx,dx,ds,si,di,st1,st2))
void PASPROC$Lock(void);
void PASPROC$Unlock(void);
#pragma restore
#ifdef __cplusplus
}
#endif

#pragma restore
#endif

