(* Copyright (C) 1990 Jensen & Partners International *)

(*%F _fdata *)
(*# call(seg_name => null) *)
(*%E *)
(*# module(implementation=>off) *)
(*# data(seg_name => null) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION UNIT PasOvl;

procedure MakeStr(dest: array [low..high: int16] of char; source: Modname);

var
  d, s: word;
begin
  d := 0;
  s := 1;
  while s <= length(source) do
    begin
    dest[d] := source[s];
    d := d+1;
    s := s+1;
    end;
  dest[d] := 0C;
end;


function LoadSeg{(SegNum: word; Name: ModName): int16};

var
  s: array [0..9] of char;
  sp: CoreSig.StrPtr;
begin
  MakeStr(s, Name);
  if s[0] <> 0C then
    sp := adr(s[0])
  else
    sp := nil;
  LoadSeg := CoreSig._overlay_loadseg(SegNum, sp);
end;

function UnloadSeg{(SegNum: word; Name: ModName): int16};

var
  s: array [0..9] of char;
  sp: CoreSig.StrPtr;
begin
  MakeStr(s, Name);
  if s[0] <> 0C then
    sp := adr(s[0])
  else
    sp := nil;
  UnloadSeg := CoreSig._overlay_unloadseg(SegNum, sp);
end;

end.
