IMPLEMENTATION UNIT HIGHSCRP;

IMPORT PASWIN,PASDOS,PASRED,PASLIB;

  IMPLEMENTATION OF HighScoreTable;
    PROCEDURE SetUp;
      VAR
        InFile:FILE OF HighTable;
        I:BYTE;
      BEGIN
        IF NOT PasRed.FindPath(filen,filename) THEN
          filename:=filen;
        Assign(InFile,filename);
        IF Exists(InFile) THEN BEGIN
          Reset(InFile);
          Read(InFile,Data);
          PasLib.Close(InFile);
        END
        ELSE
          FOR I:=0 TO 14 DO BEGIN
            Data[i].name:='Nobody';
            Data[i].score:=0
          END;
        dirty:=FALSE;
        recent:=-1;
      END;

    PROCEDURE Close;
      VAR
        OutFile:FILE OF HIGHTABLE;
      BEGIN
        IF dirty THEN BEGIN
          Assign(OutFile,filename);
          rewrite(OutFile);
          write(Outfile,Data);
          Paslib.Close(OutFile);
        END;
      END;

    PROCEDURE Display;
      VAR
        tab:PasWin.PopUpWin;
        I:BYTE;
      BEGIN
        tab.Open(22,2,40,20,PasWin.Blue,PasWin.LightGray);
        tab.WrapOn:=FALSE;
        tab.FrameDraw(PasWin.DoubleFrame,PasWin.White,PasWin.Blue,FALSE);
        tab.FrameWrite('High Scores',true,10,PasWin.White,PasWin.Blue);
        PasWin.CursorOff;
        tab.Clear(PasWin.Clear_Screen);
        ISOFormatting:=FALSE;
        FOR I:=0 TO 14 DO
          WRITELN(Data[i].name:-30,Data[i].score:10);
        IF recent>0 THEN BEGIN
          PasWin.GotoXY(10,17);
          WRITE('Your score ',recent:8)
        END;
        PasWin.GotoXY(8,18);
        WRITE('Press a key to continue');
        IF PasDos.RdKey=CHR(0) THEN
          IF PasDos.RdKey=CHR(0) THEN;
        tab.Close;
      END;

    PROCEDURE AddValue;
      LABEL 1;
      VAR I,J:BYTE;
          HS:PasWin.PopUpWin;
      BEGIN
        FOR I:=0 TO 14 DO
          IF ThisScore>data[i].score THEN BEGIN
            Dirty:=TRUE;
            FOR J:=14 DOWNTO I+1 DO
              Data[j]:=Data[j-1];
            HS.Open(18,10,44,5,PasWin.Blue,PasWin.LightGray);
            HS.FrameDraw(PasWin.DoubleFrame,PasWin.Red,PasWin.LightGray,false);
            HS.FrameWrite('Name Entry',True,12,PasWin.Blue,PasWin.LightGray);
            PasWin.CursorOn;
            HS.Clear(PasWin.clear_screen);
            WRITELN(' You have achieved one of the high scores');
            WRITELN(' Please enter your name (20 chars max)');
            PasWin.GotoXY(5,4);
            HS.ReadStr(Data[i].name);
            Data[i].score:=ThisScore;
            HS.Close;
            GOTO 1
          END;
        1:recent:=ThisScore;
      END;

  BEGIN
  END;

BEGIN
  PasRed.Init;
END.