#define TIMING 1
#define TRUE 1
#define FALSE 0
#define SIZE 8190
#define SIZEPL 8191
#pragma check(stack=>on)
#include <stdio.h>
#include <time.h>

int sieve() {
  int i,prime,k,count;
  char flags[SIZEPL];

  for(i = 0; i<=SIZE;i++)
    flags[i]=TRUE;
  count=0;
  for(i=0;i <= SIZE;i++){
    if(flags[i]){
      prime = i+i+3;
      k=i+prime;
      while(k<=SIZE){
        flags[k] = FALSE;
        k += prime;
      }
      count = count+1;
    }
  }
  return count;
}

main(){
int iter,res;
  printf("50 iterations\n");
  {
#if TIMING
    double microsec, before, after;
    before = (double)clock();
#endif
    for (iter=1;iter<=50;iter++) {
      res = sieve();
    }
#if TIMING
    after = (double)clock();
    microsec = 1e3 * (after - before) / CLK_TCK / iter;
    printf( "Time per iteration in microseconds= %f \n", microsec );
#endif
  }
  printf("%d primes\n",res);
}