/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  formio.h -  header file for Modula-2 file formatted IO procedures       *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2FORMIO_INC
#define _M2FORMIO_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma name(prefix=>"")
#pragma call(c_conv=>off)

#ifdef __cplusplus
extern "C" {
#endif
void  WrF(unsigned patH, const char *Pat) ;

void  WrF1(unsigned patH, const char *Pat,
           unsigned p1H, const void *P1);

void  WrF2(unsigned patH, const char *Pat,
           unsigned p1H, const void *P1,
           unsigned p2H, const void *P2);

void  WrF3(unsigned patH, const char *Pat,
           unsigned p1H, const void *P1,
           unsigned p2H, const void *P2,
           unsigned p3H, const void *P3);

void  WrF4(unsigned patH, const char *Pat,
           unsigned p1H, const void *P1,
           unsigned p2H, const void *P2,
           unsigned p3H, const void *P3,
           unsigned p4H, const void *P4);

void  WrF5(unsigned patH, const char *Pat,
           unsigned p1H, const void *P1,
           unsigned p2H, const void *P2,
           unsigned p3H, const void *P3,
           unsigned p4H, const void *P4,
           unsigned p5H, const void *P5);
#ifdef __cplusplus
}
#endif


#pragma restore
#endif