/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  setjmp.h -  typedef and function prototypes for setjmp and longjmp.     *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _SETJMP_INC_
#define _SETJMP_INC_

#ifndef _JMPTYPE_DEF
#define _JMPTYPE_DEF

typedef unsigned char TenByteReal[10];

typedef struct {
    unsigned  j_sp;	   /* saved X086 registers */
    unsigned  j_ss;
    unsigned  j_flag;
    unsigned  j_cs;
    unsigned  j_ip;
    unsigned  j_bp;
    unsigned  j_di;
    unsigned  j_es;
    unsigned  j_si;
    unsigned  j_ds;
    TenByteReal st1, st2;
} jmp_buf[1];
#endif

#ifdef __cplusplus
extern "C" {
#endif
#pragma save
#pragma call(reg_saved=>(ax,bx,cx,dx,ds,es,si,di,st0,st1,st2,st3,st4,st5,st6))
void  longjmp(jmp_buf _env, int _val);
#pragma call(reg_saved=>(ds,es,si,di,st1,st2), set_jmp=>on)
int   _setjmp(jmp_buf _env);
#pragma restore
#ifdef __cplusplus
}
#endif

#define setjmp(_arg) _setjmp(_arg)

#endif
