/* Release 3.00 */
/*-------------------------------------------------------------------------*
*                                                                          *
*  str.h -  header file for Modula-2 string procedures                     *
*                                                                          *
*  COPYRIGHT (C) 1989..1991 Jensen and Partners. All Rights Reserved.      *
*                                                                          *
*--------------------------------------------------------------------------*/

#ifndef _M2STR_INC
#define _M2STR_INC

#pragma project("#set tsm2='on'")

#pragma save
#pragma call(c_conv=>off)
#pragma name(prefix=>"")
#ifdef __cplusplus
extern "C" {
#endif
void          Str$Append(unsigned RH, char *R, unsigned SH, const char *S);
void          Str$Caps(unsigned SH, char *S);
int           Str$CompareStr(unsigned S1H, const char *S1, unsigned S2H, const unsigned *S2);
void          Str$Concat(unsigned RH, char *R, unsigned S1H, const char *S1, unsigned S2H, const char *S2);
void          Str$Copy(unsigned RH, char *R, unsigned SH, const char *S);
unsigned      Str$Length(unsigned SH, const char *S);
unsigned      Str$Pos(unsigned SH, const char *S, unsigned PH, const char *P);
void          Str$Slice(unsigned RH, char *R, unsigned SH, const char *S, unsigned P, unsigned L);
void          Str$Item(unsigned RH, char *R, unsigned SH, const char *S, void *T, unsigned N);
void          Str$ItemS(unsigned RH, char *R, unsigned SH, const char *S, unsigned TH, const char *T, unsigned N);
void          Str$Insert(unsigned RH, char *R, unsigned SH, const char *S, unsigned P);
void          Str$Delete(unsigned RH, char *R, unsigned P, unsigned L);
int           Str$Match(unsigned SourceH, const char *Source, unsigned PatternH, const char *Pattern);
void          Str$IntToStr(long V, unsigned SH, char *S, unsigned Base, short *OK);
void          Str$CardToStr(unsigned long V, unsigned SH, char *S, unsigned Base, short *OK);
void          Str$RealToStr(double V, unsigned Precision, short Eng, unsigned SH, char *S, short *OK);
void          Str$FixRealToStr(double V, unsigned Precision, unsigned SH, char *S, short *OK);
long          Str$StrToInt(unsigned SH, const char *S, unsigned Base, short *OK);
unsigned long Str$StrToCard (unsigned SH, const char *S, unsigned Base, short *OK);
double        Str$StrToReal(unsigned SH, const char *S, short *OK);
unsigned char Str$StrToC(unsigned SH, const char *S, unsigned SD, char *D);
unsigned char Str$StrToPas(unsigned SH, const char *S, unsigned SD, char *D);

#ifdef __cplusplus
}
#endif

#pragma restore
#endif
