IMPLEMENTATION MODULE LibMain;

PROCEDURE LIBMAIN(hInstance: Windows.HANDLE; wDataSeg, cbHeapSize: WORD;
                  lpszCmdLine: Windows.LPSTR): INTEGER;

VAR
  Ret: INTEGER;
BEGIN
  Ret := 1;
  IF hInstance = 0 THEN                   (* Call initialization procedure *)
                                          (* if this is the first instance *)
    IF Windows.LocalInit(wDataSeg, 0, cbHeapSize) = 0 THEN
      Ret := 0;                           (* error *)
    END;
  END;
  RETURN Ret;
END LIBMAIN;



PROCEDURE WEP(nParam: INTEGER) : INTEGER;

BEGIN
  IF nParam = Windows.WEP_SYSTEM_EXIT THEN
    RETURN 1;                       (* system exit *)
  END;

  IF nParam = Windows.WEP_FREE_DLL THEN
    RETURN 1;                       (* use count is zero - DLL freed *)
  ELSE
    RETURN 1;                       (* undefined, just return *)
  END;
END WEP;

END LibMain.